Index: /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/SHARED/1_namelist_ref
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/SHARED/1_namelist_ref	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/SHARED/1_namelist_ref	(revision 4292)
@@ -507,4 +507,5 @@
 !-----------------------------------------------------------------------
    ln_tide_pot   = .true.   !  use tidal potential forcing
+   nb_harmo      =    11    !  number of constituents used
    clname(1)     =   'M2'   !  name of constituent
    clname(2)     =   'S2'
@@ -700,4 +701,17 @@
    ln_dynadv_cen2= .false. !  flux form - 2nd order centered scheme
    ln_dynadv_ubs = .false. !  flux form - 3rd order UBS      scheme
+/
+!-----------------------------------------------------------------------
+&nam_vvl    !   vertical coordinate options
+!-----------------------------------------------------------------------
+   ln_vvl_zstar  = .true.           !  zstar vertical coordinate                   
+   ln_vvl_ztilde = .false.          !  ztilde vertical coordinate: only high frequency variations
+   ln_vvl_layer  = .false.          !  full layer vertical coordinate
+   ln_vvl_ztilde_as_zstar = .false. !  ztilde vertical coordinate emulating zstar
+   rn_ahe3       = 0.0e0            !  thickness diffusion coefficient
+   rn_rst_e3t    = 30.e0            !  ztilde to zstar restoration timescale [days]
+   rn_lf_cutoff  = 5.0e0            !  cutoff frequency for low-pass filter  [days]
+   rn_zdef_max   = 0.9e0            !  maximum fractional e3t deformation
+   ln_vvl_dbg    = .true.           !  debug prints    (T/F)
 /
 !-----------------------------------------------------------------------
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/SHARED/namelist_ref
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 4292)
@@ -513,4 +513,5 @@
 !-----------------------------------------------------------------------
    ln_tide_pot   = .true.   !  use tidal potential forcing
+   nb_harmo      =    11    !  number of constituents used
    clname(1)     =   'M2'   !  name of constituent
    clname(2)     =   'S2'
@@ -712,4 +713,17 @@
    ln_dynadv_cen2= .false. !  flux form - 2nd order centered scheme
    ln_dynadv_ubs = .false. !  flux form - 3rd order UBS      scheme
+/
+!-----------------------------------------------------------------------
+&nam_vvl    !   vertical coordinate options
+!-----------------------------------------------------------------------
+   ln_vvl_zstar  = .true.           !  zstar vertical coordinate                   
+   ln_vvl_ztilde = .false.          !  ztilde vertical coordinate: only high frequency variations
+   ln_vvl_layer  = .false.          !  full layer vertical coordinate
+   ln_vvl_ztilde_as_zstar = .false. !  ztilde vertical coordinate emulating zstar
+   rn_ahe3       = 0.0e0            !  thickness diffusion coefficient
+   rn_rst_e3t    = 30.e0            !  ztilde to zstar restoration timescale [days]
+   rn_lf_cutoff  = 5.0e0            !  cutoff frequency for low-pass filter  [days]
+   rn_zdef_max   = 0.9e0            !  maximum fractional e3t deformation
+   ln_vvl_dbg    = .true.           !  debug prints    (T/F)
 /
 !-----------------------------------------------------------------------
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 4292)
@@ -24,4 +24,5 @@
    USE phycst           ! physical constants
    USE dom_oce          ! ocean domain
+   USE domvvl           ! ocean vertical scale factors
    USE dom_ice_2        ! LIM-2: ice domain
    USE ice_2            ! LIM-2: ice variables
@@ -59,4 +60,5 @@
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/LIM2 4.0 , UCL - NEMO Consortium (2011)
@@ -446,4 +448,6 @@
       !!-------------------------------------------------------------------
       !
+      INTEGER :: jk           ! local integer
+      !
       IF(lwp) WRITE(numout,*)
       IF(lwp) WRITE(numout,*) 'lim_sbc_init_2 : LIM-2 sea-ice - surface boundary condition'
@@ -472,4 +476,5 @@
          snwice_mass  (:,:) = 0.e0           ! no mass exchanges
          snwice_mass_b(:,:) = 0.e0           ! no mass exchanges
+         snwice_fmass (:,:) = 0.e0           ! no mass exchanges
       ENDIF
       IF( nn_ice_embd == 2 .AND.          &  ! full embedment (case 2) & no restart : 
@@ -477,4 +482,35 @@
          sshn(:,:) = sshn(:,:) - snwice_mass(:,:) * r1_rau0
          sshb(:,:) = sshb(:,:) - snwice_mass(:,:) * r1_rau0
+         do jk = 1,jpkm1                     ! adjust initial vertical scale factors
+          fse3t_n(:,:,jk) = e3t_0(:,:,jk)*( 1._wp + sshn(:,:)*tmask(:,:,1)/(ht_0(:,:) + 1.0 - tmask(:,:,1)) )
+          fse3t_b(:,:,jk) = e3t_0(:,:,jk)*( 1._wp + sshb(:,:)*tmask(:,:,1)/(ht_0(:,:) + 1.0 - tmask(:,:,1)) )
+         end do
+         fse3t_a(:,:,:) = fse3t_b(:,:,:)
+         ! Reconstruction of all vertical scale factors at now and before time steps
+         ! =============================================================================
+         ! Horizontal scale factor interpolations
+         ! --------------------------------------
+         CALL dom_vvl_interpol( fse3t_b(:,:,:), fse3u_b(:,:,:), 'U' )
+         CALL dom_vvl_interpol( fse3t_b(:,:,:), fse3v_b(:,:,:), 'V' )
+         CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3u_n(:,:,:), 'U' )
+         CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3v_n(:,:,:), 'V' )
+         CALL dom_vvl_interpol( fse3u_n(:,:,:), fse3f_n(:,:,:), 'F' )
+         ! Vertical scale factor interpolations
+         ! ------------------------------------
+         CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3w_n (:,:,:), 'W'  )
+         CALL dom_vvl_interpol( fse3u_n(:,:,:), fse3uw_n(:,:,:), 'UW' )
+         CALL dom_vvl_interpol( fse3v_n(:,:,:), fse3vw_n(:,:,:), 'VW' )
+         CALL dom_vvl_interpol( fse3u_b(:,:,:), fse3uw_b(:,:,:), 'UW' )
+         CALL dom_vvl_interpol( fse3v_b(:,:,:), fse3vw_b(:,:,:), 'VW' )
+         ! t- and w- points depth
+         ! ----------------------
+         fsdept_n(:,:,1) = 0.5_wp * fse3w_n(:,:,1)
+         fsdepw_n(:,:,1) = 0.0_wp
+         fsde3w_n(:,:,1) = fsdept_n(:,:,1) - sshn(:,:)
+         DO jk = 2, jpk
+            fsdept_n(:,:,jk) = fsdept_n(:,:,jk-1) + fse3w_n(:,:,jk)
+            fsdepw_n(:,:,jk) = fsdepw_n(:,:,jk-1) + fse3t_n(:,:,jk-1)
+            fsde3w_n(:,:,jk) = fsdept_n(:,:,jk  ) - sshn   (:,:)
+         END DO
       ENDIF
       !
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90	(revision 4292)
@@ -237,5 +237,5 @@
             
             !  energy needed to bring ocean surface layer until its freezing
-            qcmif  (ji,jj) =  rau0 * rcp * fse3t_m(ji,jj,1) * ( tfu(ji,jj) - sst_m(ji,jj) - rt0 ) * ( 1 - zinda )
+            qcmif  (ji,jj) =  rau0 * rcp * fse3t_m(ji,jj) * ( tfu(ji,jj) - sst_m(ji,jj) - rt0 ) * ( 1 - zinda )
             
             !  calculate oceanic heat flux.
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/NST_SRC/agrif_oce.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/NST_SRC/agrif_oce.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/NST_SRC/agrif_oce.F90	(revision 4292)
@@ -40,4 +40,5 @@
    INTEGER :: e1u_id, e2v_id, sshn_id, gcb_id
    INTEGER :: trn_id, trb_id, tra_id
+   INTEGER :: unb_id, vnb_id
 
    !!----------------------------------------------------------------------
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/NST_SRC/agrif_opa_interp.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/NST_SRC/agrif_opa_interp.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/NST_SRC/agrif_opa_interp.F90	(revision 4292)
@@ -27,10 +27,19 @@
    USE agrif_opa_sponge
    USE lib_mpp
-   USE wrk_nemo  
+   USE wrk_nemo
+   USE dynspg_oce  
 
    IMPLICIT NONE
    PRIVATE
+
+   ! Barotropic arrays used to store open boundary data during
+   ! time-splitting loop:
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::  ubdy_w, vbdy_w, hbdy_w
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::  ubdy_e, vbdy_e, hbdy_e
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::  ubdy_n, vbdy_n, hbdy_n
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::  ubdy_s, vbdy_s, hbdy_s
     
-   PUBLIC   Agrif_tra, Agrif_dyn, Agrif_ssh, interpu, interpv
+   PUBLIC   Agrif_tra, Agrif_dyn, Agrif_ssh, Agrif_dyn_ts, Agrif_ssh_ts
+   PUBLIC   interpu, interpv, interpunb, interpvnb, interpsshn
 
 #  include "domzgr_substitute.h90"  
@@ -169,5 +178,5 @@
       REAL(wp) :: timeref
       REAL(wp) :: z2dt, znugdt
-      REAL(wp) :: zrhox, rhoy
+      REAL(wp) :: zrhox, zrhoy
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zua, zva
       REAL(wp), POINTER, DIMENSION(:,:) :: spgv1, spgu1, zua2d, zva2d
@@ -180,5 +189,5 @@
 
       zrhox = Agrif_Rhox()
-      rhoy = Agrif_Rhoy()
+      zrhoy = Agrif_Rhoy()
 
       timeref = 1.
@@ -201,8 +210,10 @@
       zva2d = 0.
 
+#if defined key_dynspg_flt
       Agrif_SpecialValue=0.
       Agrif_UseSpecialValue = ln_spc_dyn
       CALL Agrif_Bc_variable(zua2d,e1u_id,calledweight=1.,procname=interpu2d)
       CALL Agrif_Bc_variable(zva2d,e2v_id,calledweight=1.,procname=interpv2d)
+#endif
       Agrif_UseSpecialValue = .FALSE.
 
@@ -210,15 +221,18 @@
       IF((nbondi == -1).OR.(nbondi == 2)) THEN
 
+#if defined key_dynspg_flt
          DO jj=1,jpj
-            laplacu(2,jj) = timeref * (zua2d(2,jj)/(rhoy*e2u(2,jj)))*umask(2,jj,1)
-         END DO
-
-         DO jk=1,jpkm1
-            DO jj=1,jpj
-               ua(1:2,jj,jk) = (zua(1:2,jj,jk)/(rhoy*e2u(1:2,jj)))
+            laplacu(2,jj) = timeref * (zua2d(2,jj)/(zrhoy*e2u(2,jj)))*umask(2,jj,1)
+         END DO
+#endif
+
+         DO jk=1,jpkm1
+            DO jj=1,jpj
+               ua(1:2,jj,jk) = (zua(1:2,jj,jk)/(zrhoy*e2u(1:2,jj)))
                ua(1:2,jj,jk) = ua(1:2,jj,jk) / fse3u(1:2,jj,jk)
             END DO
          END DO
 
+#if defined key_dynspg_flt
          DO jk=1,jpkm1
             DO jj=1,jpj
@@ -240,4 +254,7 @@
             ENDIF
          END DO
+#else
+         spgu(2,:) = ua_b(2,:)
+#endif
 
          DO jk=1,jpkm1
@@ -278,12 +295,13 @@
 
       IF((nbondi == 1).OR.(nbondi == 2)) THEN
-
+#if defined key_dynspg_flt
          DO jj=1,jpj
-            laplacu(nlci-2,jj) = timeref * (zua2d(nlci-2,jj)/(rhoy*e2u(nlci-2,jj)))
-         END DO
-
-         DO jk=1,jpkm1
-            DO jj=1,jpj
-               ua(nlci-2:nlci-1,jj,jk) = (zua(nlci-2:nlci-1,jj,jk)/(rhoy*e2u(nlci-2:nlci-1,jj)))
+            laplacu(nlci-2,jj) = timeref * (zua2d(nlci-2,jj)/(zrhoy*e2u(nlci-2,jj)))
+         END DO
+#endif
+
+         DO jk=1,jpkm1
+            DO jj=1,jpj
+               ua(nlci-2:nlci-1,jj,jk) = (zua(nlci-2:nlci-1,jj,jk)/(zrhoy*e2u(nlci-2:nlci-1,jj)))
 
                ua(nlci-2:nlci-1,jj,jk) = ua(nlci-2:nlci-1,jj,jk) / fse3u(nlci-2:nlci-1,jj,jk)
@@ -292,4 +310,5 @@
          END DO
 
+#if defined key_dynspg_flt
          DO jk=1,jpkm1
             DO jj=1,jpj
@@ -312,4 +331,7 @@
             ENDIF
          END DO
+#else
+         spgu(nlci-2,:) = ua_b(nlci-2,:)
+#endif
 
          DO jk=1,jpkm1
@@ -353,7 +375,9 @@
       IF((nbondj == -1).OR.(nbondj == 2)) THEN
 
+#if defined key_dynspg_flt
          DO ji=1,jpi
             laplacv(ji,2) = timeref * (zva2d(ji,2)/(zrhox*e1v(ji,2)))
          END DO
+#endif
 
          DO jk=1,jpkm1
@@ -364,4 +388,5 @@
          END DO
 
+#if defined key_dynspg_flt
          DO jk=1,jpkm1
             DO ji=1,jpi
@@ -383,4 +408,7 @@
             ENDIF
          END DO
+#else
+         spgv(:,2)=va_b(:,2)
+#endif
 
          DO jk=1,jpkm1
@@ -413,5 +441,5 @@
          DO jk=1,jpkm1
             DO ji=1,jpi
-               ua(ji,2,jk) = (zua(ji,2,jk)/(rhoy*e2u(ji,2)))*umask(ji,2,jk) 
+               ua(ji,2,jk) = (zua(ji,2,jk)/(zrhoy*e2u(ji,2)))*umask(ji,2,jk) 
                ua(ji,2,jk) = ua(ji,2,jk) / fse3u(ji,2,jk)
             END DO
@@ -422,7 +450,9 @@
       IF((nbondj == 1).OR.(nbondj == 2)) THEN
 
+#if defined key_dynspg_flt
          DO ji=1,jpi
             laplacv(ji,nlcj-2) = timeref * (zva2d(ji,nlcj-2)/(zrhox*e1v(ji,nlcj-2)))
          END DO
+#endif
 
          DO jk=1,jpkm1
@@ -433,4 +463,5 @@
          END DO
 
+#if defined key_dynspg_flt
          DO jk=1,jpkm1
             DO ji=1,jpi
@@ -438,5 +469,4 @@
             END DO
          END DO
-
 
          spgv(:,nlcj-2)=0.
@@ -453,4 +483,7 @@
             ENDIF
          END DO
+#else
+         spgv(:,nlcj-2)=va_b(:,nlcj-2)
+#endif
 
          DO jk=1,jpkm1
@@ -483,5 +516,5 @@
          DO jk=1,jpkm1
             DO ji=1,jpi
-               ua(ji,nlcj-1,jk) = (zua(ji,nlcj-1,jk)/(rhoy*e2u(ji,nlcj-1)))*umask(ji,nlcj-1,jk)
+               ua(ji,nlcj-1,jk) = (zua(ji,nlcj-1,jk)/(zrhoy*e2u(ji,nlcj-1)))*umask(ji,nlcj-1,jk)
                ua(ji,nlcj-1,jk) = ua(ji,nlcj-1,jk) / fse3u(ji,nlcj-1,jk)
             END DO
@@ -495,4 +528,128 @@
    END SUBROUTINE Agrif_dyn
 
+   SUBROUTINE Agrif_dyn_ts( kt, jn )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE Agrif_dyn_ts  ***
+      !!----------------------------------------------------------------------  
+      !! 
+      INTEGER, INTENT(in) ::   kt, jn
+      !!
+      INTEGER :: ji, jj
+      REAL(wp) :: zrhox, zrhoy
+      REAL(wp), POINTER, DIMENSION(:,:) :: spgv1, spgu1
+      REAL(wp), POINTER, DIMENSION(:,:) :: zunb, zvnb, zsshn
+      !!----------------------------------------------------------------------  
+
+      IF( Agrif_Root() )   RETURN
+
+      IF ((kt==nit000).AND.(jn==1)) THEN
+         ALLOCATE( ubdy_w(jpj), vbdy_w(jpj), hbdy_w(jpj))
+         ALLOCATE( ubdy_e(jpj), vbdy_e(jpj), hbdy_e(jpj))
+         ALLOCATE( ubdy_n(jpi), vbdy_n(jpi), hbdy_n(jpi))
+         ALLOCATE( ubdy_s(jpi), vbdy_s(jpi), hbdy_s(jpi))
+      ENDIF
+
+      IF (jn==1) THEN 
+         ! Fill boundary arrays at each baroclinic step 
+         ! with Parent grid barotropic fluxes and sea level
+         !
+         CALL wrk_alloc( jpi, jpj, zunb, zvnb, zsshn )
+
+         zrhox = Agrif_Rhox()
+         zrhoy = Agrif_Rhoy()
+
+!alt         Agrif_SpecialValue    = 0.e0
+!alt         Agrif_UseSpecialValue = .TRUE.
+!alt         CALL Agrif_Bc_variable(zsshn, sshn_id, procname=interpsshn )
+!alt         Agrif_UseSpecialValue = .FALSE.
+
+         Agrif_SpecialValue=0.
+         Agrif_UseSpecialValue = ln_spc_dyn
+         zunb(:,:) = 0._wp ; zvnb(:,:) = 0._wp
+         CALL Agrif_Bc_variable(zunb,unb_id,procname=interpunb)
+         CALL Agrif_Bc_variable(zvnb,vnb_id,procname=interpvnb)
+         Agrif_UseSpecialValue = .FALSE.
+
+         IF((nbondi == -1).OR.(nbondi == 2)) THEN
+            DO jj=1,jpj
+               ubdy_w(jj) = (zunb(2,jj)/(zrhoy*e2u(2,jj)))
+               vbdy_w(jj) = (zvnb(2,jj)/(zrhox*e1v(2,jj)))
+               hbdy_w(jj) = zsshn(2,jj)
+            END DO
+         ENDIF
+
+         IF((nbondi == 1).OR.(nbondi == 2)) THEN
+            DO jj=1,jpj
+               ubdy_e(jj) = zunb(nlci-2,jj)/(zrhoy*e2u(nlci-2,jj))
+               vbdy_e(jj) = zvnb(nlci-1,jj)/(zrhox*e1v(nlci-1,jj))
+               hbdy_e(jj) = zsshn(nlci-1,jj)
+            END DO
+         ENDIF
+
+         IF((nbondj == -1).OR.(nbondj == 2)) THEN
+            DO ji=1,jpi
+               ubdy_s(ji) = zunb(ji,2)/(zrhoy*e2u(ji,2))
+               vbdy_s(ji) = zvnb(ji,2)/(zrhox*e1v(ji,2))
+               hbdy_s(ji) = zsshn(ji,2)
+            END DO
+         ENDIF
+
+         IF((nbondj == 1).OR.(nbondj == 2)) THEN
+            DO ji=1,jpi
+               ubdy_n(ji) = zunb(ji,nlcj-1)/(zrhoy*e2u(ji,nlcj-1))
+               vbdy_n(ji) = zvnb(ji,nlcj-2)/(zrhox*e1v(ji,nlcj-2))
+               hbdy_n(ji) = zsshn(ji,nlcj-1)
+            END DO
+         ENDIF
+
+         CALL wrk_dealloc( jpi, jpj, zunb, zvnb, zsshn )
+      ENDIF ! jn==1
+
+      ! Then update velocities at each barotropic time step
+      IF((nbondi == -1).OR.(nbondi == 2)) THEN
+         DO jj=1,jpj
+            va_e(2,jj) = vbdy_w(jj) * hvr_e(2,jj)
+! Specified fluxes:
+            ua_e(2,jj) = ubdy_w(jj) * hur_e(2,jj)
+! Characteristics method:
+!alt            ua_e(2,jj) = 0.5_wp * ( ubdy_w(jj) * hur_e(2,jj) + ua_e(3,jj) &
+!alt                       &           - sqrt(grav * hur_e(2,jj)) * (sshn_e(3,jj) - hbdy_w(jj)) )
+         END DO
+      ENDIF
+
+      IF((nbondi == 1).OR.(nbondi == 2)) THEN
+         DO jj=1,jpj
+            va_e(nlci-1,jj) = vbdy_e(jj) * hvr_e(nlci-1,jj)
+! Specified fluxes:
+            ua_e(nlci-2,jj) = ubdy_e(jj) * hur_e(nlci-2,jj)
+! Characteristics method:
+!alt            ua_e(nlci-2,jj) = 0.5_wp * ( ubdy_e(jj) * hur_e(nlci-2,jj) + ua_e(nlci-3,jj) &
+!alt                            &           + sqrt(grav * hur_e(nlci-2,jj)) * (sshn_e(nlci-2,jj) - hbdy_e(jj)) )
+         END DO
+      ENDIF
+
+      IF((nbondj == -1).OR.(nbondj == 2)) THEN
+         DO ji=1,jpi
+            ua_e(ji,2) = ubdy_s(ji) * hur_e(ji,2)
+! Specified fluxes:
+            va_e(ji,2) = vbdy_s(ji) * hvr_e(ji,2)
+! Characteristics method:
+!alt            va_e(ji,2) = 0.5_wp * ( vbdy_s(ji) * hvr_e(ji,2) + va_e(ji,3) &
+!alt                       &           - sqrt(grav * hvr_e(ji,2)) * (sshn_e(ji,3) - hbdy_s(ji)) )
+         END DO
+      ENDIF
+
+      IF((nbondj == 1).OR.(nbondj == 2)) THEN
+         DO ji=1,jpi
+            ua_e(ji,nlcj-1) = ubdy_n(ji) * hur_e(ji,nlcj-1)
+! Specified fluxes:
+            va_e(ji,nlcj-2) = vbdy_n(ji) * hvr_e(ji,nlcj-2)
+! Characteristics method:
+!alt            va_e(ji,nlcj-2) = 0.5_wp * ( vbdy_n(ji) * hvr_e(ji,nlcj-2)  + va_e(ji,nlcj-3) &
+!alt                            &           + sqrt(grav * hvr_e(ji,nlcj-2)) * (sshn_e(ji,nlcj-2) - hbdy_n(ji)) )
+         END DO
+      ENDIF
+      !
+   END SUBROUTINE Agrif_dyn_ts
 
    SUBROUTINE Agrif_ssh( kt )
@@ -518,15 +675,54 @@
 
       IF((nbondj == -1).OR.(nbondj == 2)) THEN
-         ssha(:,2)=sshn(:,3)
-         sshn(:,2)=sshb(:,3)
+         ssha(:,2)=ssha(:,3)
+         sshn(:,2)=sshn(:,3)
       ENDIF
 
       IF((nbondj == 1).OR.(nbondj == 2)) THEN
          ssha(:,nlcj-1)=ssha(:,nlcj-2)
-         ssha(:,nlcj-1)=sshn(:,nlcj-2)                
+         sshn(:,nlcj-1)=sshn(:,nlcj-2)                
       ENDIF
 
    END SUBROUTINE Agrif_ssh
 
+   SUBROUTINE Agrif_ssh_ts( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE Agrif_ssh_ts  ***
+      !!----------------------------------------------------------------------  
+      INTEGER, INTENT(in) ::   kt
+      !!
+      !!----------------------------------------------------------------------  
+
+      IF((nbondi == -1).OR.(nbondi == 2)) THEN
+         ssha_e(2,:) = ssha_e(3,:)
+      ENDIF
+
+      IF((nbondi == 1).OR.(nbondi == 2)) THEN
+         ssha_e(nlci-1,:) = ssha_e(nlci-2,:)    
+      ENDIF
+
+      IF((nbondj == -1).OR.(nbondj == 2)) THEN
+         ssha_e(:,2) = ssha_e(:,3)
+      ENDIF
+
+      IF((nbondj == 1).OR.(nbondj == 2)) THEN
+         ssha_e(:,nlcj-1) = ssha_e(:,nlcj-2)            
+      ENDIF
+
+   END SUBROUTINE Agrif_ssh_ts
+
+   SUBROUTINE interpsshn(tabres,i1,i2,j1,j2)
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE interpsshn  ***
+      !!----------------------------------------------------------------------  
+      INTEGER, INTENT(in) :: i1,i2,j1,j2
+      REAL(wp), DIMENSION(i1:i2,j1:j2), INTENT(inout) :: tabres
+      !!
+      INTEGER :: ji,jj
+      !!----------------------------------------------------------------------  
+
+      tabres(i1:i2,j1:j2) = sshn(i1:i2,j1:j2)
+
+   END SUBROUTINE interpsshn
 
    SUBROUTINE interpu(tabres,i1,i2,j1,j2,k1,k2)
@@ -611,4 +807,48 @@
 
    END SUBROUTINE interpv2d
+
+   SUBROUTINE interpunb(tabres,i1,i2,j1,j2)
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE interpunb  ***
+      !!----------------------------------------------------------------------  
+      INTEGER, INTENT(in) :: i1,i2,j1,j2
+      REAL(wp), DIMENSION(i1:i2,j1:j2), INTENT(inout) :: tabres
+      !!
+      INTEGER :: ji,jj,jk
+      !!----------------------------------------------------------------------  
+
+      tabres(:,:) = 0.e0
+      DO jk=1,jpkm1
+         DO jj=j1,j2
+            DO ji=i1,i2
+               tabres(ji,jj) = tabres(ji,jj) + e2u(ji,jj) * un(ji,jj,jk) &
+                  * umask(ji,jj,jk) * fse3u(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+
+   END SUBROUTINE interpunb
+
+   SUBROUTINE interpvnb(tabres,i1,i2,j1,j2)
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE interpvnb  ***
+      !!----------------------------------------------------------------------  
+      INTEGER, INTENT(in) :: i1,i2,j1,j2
+      REAL(wp), DIMENSION(i1:i2,j1:j2), INTENT(inout) :: tabres
+      !!
+      INTEGER :: ji,jj,jk
+      !!----------------------------------------------------------------------  
+
+      tabres(:,:) = 0.e0
+      DO jk=1,jpkm1
+         DO jj=j1,j2
+            DO ji=i1,i2
+               tabres(ji,jj) = tabres(ji,jj) + e1v(ji,jj) * vn(ji,jj,jk) &
+                  * vmask(ji,jj,jk) * fse3v(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+
+   END SUBROUTINE interpvnb
 
 #else
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OFF_SRC/domain.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OFF_SRC/domain.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OFF_SRC/domain.F90	(revision 4292)
@@ -295,5 +295,5 @@
       !!      vertical scale factors.
       !!
-      !! ** Method  : - reference 1D vertical coordinate (gdep._0, e3._0)
+      !! ** Method  : - reference 1D vertical coordinate (gdep._1d, e3._1d)
       !!              - read/set ocean depth and ocean levels (bathy, mbathy)
       !!              - vertical coordinate (gdep., e3.) depending on the 
